<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>MessageExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges</a> &gt; <span class="el_source">MessageExchange.java</span></div><h1>MessageExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges;

import java.util.*;
import java.util.function.Predicate;
import java.util.stream.Collectors;

import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.resources.Registry;

/**
 * This is a queue for exchanging messages between producers and consumers.
 * &lt;br&gt;
 * The implementations are wrapper over existing queue implementations. They hide away the knowledge/code required to efficiently use them.
 * The applications can use an implementation or switch to another, without make any code changes.
 * It can also choose implementations based on their use case and whether the underlying has a different strategy for multiple or single producers.
 * &lt;br&gt;
 * It supports a variety of blocking and non-blocking operations.
 * &lt;br&gt;
 * All implementations support the notion of a terminal state. When a terminal element is submitted to the exchange, all the readers will receive it, marking the end of all future transmission.
 *
 * @param &lt;E&gt; The getType of messages in the exchange.
 * @author Varun Anand
 * @since 1.0
 */
public interface MessageExchange&lt;E&gt; {

	/**
	 * Repository for all configured executors.
	 */
<span class="fc" id="L50">	Registry&lt;Factory&gt; REGISTRY = new Registry&lt;&gt;();</span>

	/**
	 * The factory method for all implementations.
	 * This method will be configured in {@link #REGISTRY} to facilitate lookup and creation of instance by their {@link String} getType.
	 */
	interface Factory {
		&lt;E&gt; MessageExchange&lt;E&gt; newInstance(final int capacity, final boolean isMultiProducer, final Config props);
	}

	/**
	 * Provides an instance of {@link Reader} for this exchange. The implementation can return a cached instance, if it's thread-safe.
	 *
	 * @return a reader
	 */
	Reader&lt;E&gt; getReader();

	/**
	 * Provides an instance of {@link Writer} for this exchange. The implementation can return a cached instance, if it's thread-safe.
	 *
	 * @return a writer
	 */
	Writer&lt;E&gt; newWriter();

	boolean isEmpty();

	void shutdown();

	/**
	 * An interface to read from a resource.
	 * &lt;br&gt;
	 * Access by different threads  - The implementations don't support concurrent access but can be accessed serially.
	 * However, there are methods to support pub-sub &lt;i&gt;like&lt;/i&gt; scenarios.
	 *
	 * @param &lt;E&gt; the getType of event expected to be read.
	 */
	interface Reader&lt;E&gt; {

		/**
		 * Try to retrieve an element. This is a non-blocking operation.
		 *
		 * @return a message if available, or null otherwise.
		 */
		E poll();

		/**
		 * Try to retrieve an element. This is a non-blocking operation.
		 *
		 * @param min         the minimum elements to read, unless maxAttempts have exhausted.
		 * @param max         the maximum elements to read
		 * @param maxAttempts the maximum attempts to read before returning a {@link Collections#emptyList()}
		 * @return a {@link List} of elements, if they're available until shutdown or maxAttempts are exhausted, or {@link Collections#emptyList()} otherwise.
		 */
		List&lt;E&gt; poll(int min, int max, int maxAttempts);

		default List&lt;E&gt; poll(int max, int maxAttempts) {
			List&lt;E&gt; messages;
<span class="pc bpc" id="L107" title="1 of 2 branches missed.">			for (int i = 0; i &lt; maxAttempts; i++) {</span>
<span class="fc" id="L108">				messages = poll(max);</span>
<span class="fc bfc" id="L109" title="All 2 branches covered.">				if (!messages.isEmpty()) {</span>
<span class="fc" id="L110">					return messages;</span>
<span class="pc bpc" id="L111" title="1 of 2 branches missed.">				} else if (messages == Collections.emptyList()) {</span>
<span class="fc" id="L112">					break;</span>
				}
			}
<span class="fc" id="L115">			return Collections.emptyList();</span>
		}

		/**
		 * Try to retrieve a number of element until available and the maximum limit is not reached. This is a non-blocking operation.
		 *
		 * @param max the maximum elements to read
		 * @return a {@link List} of elements, if they're available until maximum limit is reached, or {@link Collections#emptyList()} otherwise.
		 */
		List&lt;E&gt; poll(int max);

		boolean poll(int maxAttempts, Predicate&lt;? super E&gt; consumer);

		default boolean poll(int maxAttempts, Predicate&lt;? super E&gt;... consumers) {
<span class="fc" id="L129">			final List&lt;Predicate&lt;? super E&gt;&gt; activeConsumers = Arrays.stream(consumers).collect(Collectors.toList());</span>
<span class="fc bfc" id="L130" title="All 6 branches covered.">			return poll(maxAttempts, e -&gt; !(activeConsumers.removeIf(c -&gt; !c.test(e)) &amp;&amp; activeConsumers.isEmpty()));</span>
		}

		default boolean poll(int min, int max, int maxAttempts, Predicate&lt;List&lt;? super E&gt;&gt; consumer) {
			for (List&lt;? super E&gt; messages; ; ) {
<span class="fc" id="L135">				messages = poll(min, max, maxAttempts);</span>
<span class="fc bfc" id="L136" title="All 2 branches covered.">				if (messages.isEmpty()) {</span>
<span class="fc" id="L137">					return false;</span>
<span class="fc bfc" id="L138" title="All 2 branches covered.">				} else if (!consumer.test(messages)) {</span>
<span class="fc" id="L139">					return true;</span>
				}
			}
		}

		default boolean poll(int min, int max, int maxAttempts, Predicate&lt;List&lt;? super E&gt;&gt;... consumers) {
<span class="fc" id="L145">			final List&lt;Predicate&lt;List&lt;? super E&gt;&gt;&gt; activeConsumers = Arrays.stream(consumers).collect(Collectors.toList());</span>
<span class="fc bfc" id="L146" title="All 6 branches covered.">			return poll(min, max, maxAttempts, e -&gt; !(activeConsumers.removeIf(c -&gt; !c.test(e)) &amp;&amp; activeConsumers.isEmpty()));</span>
//			final Map&lt;Predicate&lt;List&lt;? super E&gt;&gt;, Boolean&gt; consumerMap = new HashMap&lt;&gt;();
//			Arrays.stream(consumers).forEach(c  -&gt; consumerMap.put(c, true));
//			return poll(min, max, maxAttempts,
//					e -&gt; consumerMap.entrySet().stream().filter(Map.Entry::getValue).map(Map.Entry::getKey).anyMatch(c -&gt; {
//						if (c.test(e)) {
//							return true;
//						} else {
//							consumerMap.put(c, false);
//							return false;
//						}
//					}));
		}

		/**
		 * Try to retrieve a number of element until available and the maximum limit is not reached. This is a non-blocking operation.
		 *
		 * @param max
		 * @param maxAttempts
		 * @param consumer
		 * @return 'false' when there are no messages to read and the max attempts are exhausted
		 * or 'true' when consumer doesn't wish to consume further i.e. the consumer predicate returns false.
		 */
		default boolean poll(int max, int maxAttempts, Predicate&lt;List&lt;? super E&gt;&gt; consumer) {
			for (List&lt;? super E&gt; messages; ; ) {
<span class="fc" id="L171">				messages = poll(max, maxAttempts);</span>
<span class="fc bfc" id="L172" title="All 2 branches covered.">				if (messages.isEmpty()) {</span>
<span class="fc" id="L173">					return false;</span>
<span class="fc bfc" id="L174" title="All 2 branches covered.">				} else if (!consumer.test(messages)) {</span>
<span class="fc" id="L175">					return true;</span>
				}
			}
		}

		default boolean poll(int max, int maxAttempts, Predicate&lt;List&lt;? super E&gt;&gt;... consumers) {
<span class="fc" id="L181">			final List&lt;Predicate&lt;List&lt;? super E&gt;&gt;&gt; activeConsumers = Arrays.stream(consumers).collect(Collectors.toList());</span>
<span class="fc bfc" id="L182" title="All 6 branches covered.">			return poll(max, maxAttempts, e -&gt; !(activeConsumers.removeIf(c -&gt; !c.test(e)) &amp;&amp; activeConsumers.isEmpty()));</span>
		}

		/**
		 * Retrieve a message or block the call otherwise.
		 *
		 * @return the element if one is readily available or blocking the call until one is available or null if the exchange has been shutdown.
		 * The application need not check for null unless it's a valid value or it intends to shutdown the exchange in some case.
		 */
		E take();

		/**
		 * Try to retrieve an element. This is a blocking operation.
		 *
		 * @param min the minimum elements to read
		 * @param max the maximum elements to read
		 * @return a {@link List} of elements, if they're available until a terminal state is read or maxAttempts are exhausted, or {@link Collections#emptyList()} otherwise.
		 */
//		default List&lt;E&gt; take(int min, int max) {
//			return poll(min, max, INFINITE);
//		}
		List&lt;E&gt; take(int min, int max);

		/**
		 * Try to retrieve an element. This is a blocking operation.
		 *
		 * @param min the minimum elements to read
		 * @return a {@link List} of elements, if they're available until a terminal state is read or maxAttempts are exhausted, or {@link Collections#emptyList()} otherwise.
		 */
//		default List&lt;E&gt; take(int min) {
//			return take(min, INFINITE);
//		}
		List&lt;E&gt; take(int min);

		/**
		 * Retrieve a message and forward it to the consumer, if one is available or block the call otherwise.
		 *
		 * @param consumer the consumer for the elements. It'll receive the elements until a terminal state is encountered or the consumer returns &lt;i&gt;false&lt;/i&gt;.
		 */
		void take(Predicate&lt;? super E&gt; consumer);

		/**
		 * Retrieve a message and forward it to the consumer, if one is available or block the call otherwise.
		 *
		 * @param consumers the consumers for the elements. They'll receive the elements until a terminal state is encountered or the consumer returns &lt;i&gt;false&lt;/i&gt;.
		 */
		default void take(Predicate&lt;? super E&gt;... consumers) {
<span class="fc" id="L229">			final List&lt;Predicate&lt;? super E&gt;&gt; activeConsumers = Arrays.stream(consumers).collect(Collectors.toList());</span>
<span class="fc bfc" id="L230" title="All 6 branches covered.">			take(e -&gt; !(activeConsumers.removeIf(c -&gt; !c.test(e)) &amp;&amp; activeConsumers.isEmpty()));</span>
<span class="fc" id="L231">		}</span>

		default void take(int min, int max, Predicate&lt;List&lt;E&gt;&gt; consumer) {
<span class="nc bnc" id="L234" title="All 4 branches missed.">			for (List&lt;E&gt; messages; ((messages = take(min, max)) != Collections.emptyList()) &amp;&amp; consumer.test(messages); Thread.yield()) ;</span>
<span class="nc" id="L235">		}</span>

		/**
		 * Retrieve a message and forward it to the consumers, if one is available or block the call otherwise.
		 *
		 * @param min       the minimum elements to read
		 * @param max       the maximum elements to read
		 * @param consumers the consumers for the elements. They'll receive the elements until a terminal state is encountered or the consumer returns &lt;i&gt;false&lt;/i&gt;.
		 */
		default void take(int min, int max, Predicate&lt;List&lt;E&gt;&gt;... consumers) {
<span class="nc" id="L245">			final List&lt;Predicate&lt;List&lt;E&gt;&gt;&gt; activeConsumers = Arrays.stream(consumers).collect(Collectors.toList());</span>
<span class="nc bnc" id="L246" title="All 6 branches missed.">			take(min, max, b -&gt; !(activeConsumers.removeIf(c -&gt; !c.test(b)) &amp;&amp; activeConsumers.isEmpty()));</span>
<span class="nc" id="L247">		}</span>

		default void take(int min, Predicate&lt;List&lt;E&gt;&gt; consumer) {
<span class="nc bnc" id="L250" title="All 4 branches missed.">			for (List&lt;E&gt; messages; ((messages = take(min)) != Collections.emptyList()) &amp;&amp; consumer.test(messages); Thread.yield()) ;</span>
<span class="nc" id="L251">		}</span>

		default void take(int min, Predicate&lt;List&lt;E&gt;&gt;... consumers) {
<span class="nc" id="L254">			final List&lt;Predicate&lt;List&lt;E&gt;&gt;&gt; activeConsumers = Arrays.stream(consumers).collect(Collectors.toList());</span>
<span class="nc bnc" id="L255" title="All 6 branches missed.">			take(min, b -&gt; !(activeConsumers.removeIf(c -&gt; !c.test(b)) &amp;&amp; activeConsumers.isEmpty()));</span>
<span class="nc" id="L256">		}</span>

	}

	interface Writer&lt;E&gt; {

		/**
		 * put an element in the exchange.
		 *
		 * @param e the element to add.
		 */
		boolean put(E e);

	}

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>